import type { OperationMiddlewareHandler } from 'executable-openapi-middleware';
import { InvalidParameterError } from 'executable-openapi-parameters';
import { Format } from 'ajv/dist/2020';
import { ResponsesObject } from 'openapi3-ts';
import { OperationExecutionResponse } from 'executable-openapi-types';
declare type RefResolver = ($ref: string) => Promise<unknown>;
export declare type ExecutableOpenAPIMiddlewareQueryParametersFormat = Format;
export interface ExecutableOpenAPIMiddlewareQueryParametersOption {
    /**
     * A JSON reference resolver that'll be used to resolve
     * JSON references found in `document`.
     *
     * If not provided, `createRouter` will use a simple resolver
     * that only resolves local JSON pointer.
     */
    documentRefResolver?: RefResolver;
    formatErrorResponse?: (error: InvalidParameterError, responseObject: ResponsesObject) => OperationExecutionResponse | Promise<OperationExecutionResponse>;
    /**
     * An object with format definitions.
     */
    formats?: {
        [Name in string]?: ExecutableOpenAPIMiddlewareQueryParametersFormat;
    };
}
export declare const executableOpenAPIMiddlewareQueryParameters: <TExecutionContext>({ documentRefResolver, formatErrorResponse, formats }?: ExecutableOpenAPIMiddlewareQueryParametersOption) => OperationMiddlewareHandler<TExecutionContext>;
export {};
